import java.util.Date;
import java.util.Random;


public abstract class Agent {
	public static Random r = new Random(new Date().getTime());
	public static final int CLEAN = 0;
	public static final int DIRTY = 1;
	public static final int WALL = 2;
	public static final int AGENT =3;

	int state = 0;
	
	private World world;
	
	public Agent(){
		
	}
	
	public void putInWorld(World w){
		world= w;
	}
	
	public boolean decide(int lastmove, int chosen, int clean) {
		if (lastmove==chosen)
			if (r.nextInt(clean+1) == 0) 
				return true;
			else
				return false;
		return true;
	}
	
	public abstract void act();
		/*add code of agent here*/
		
	
	
		
	/* =========================================================================================== */
	/* ================================= DO NOTMODIFY ============================================ */
	/* =========================================================================================== */
		
	public void moveFW(){
		world.moveFW(this);
	}
	
	public void turnRIGHT(){
		world.turnRIGHT(this);
	}
	
	public void turnLEFT(){
		world.turnLEFT(this);
	}
	
	public void suck(){
		world.suck(this);
	}
	
	public int[][] percept(){
		return world.percept(this);
	}
	
	public int getPerception(){
		return world.getPerception();
	}

	
	

	
	
}
